package andante.apps.keyboardproxy;

import java.io.FileInputStream;
import java.net.URL;

import org.omg.CORBA.ORB;
import org.omg.PortableServer.POA;

import andante.AgletsServer;
import andante.orb.MessageType;
import andante.orb.agent.MusicalAgent;
import andante.orb.agent.MusicalAgentProxy;
import andante.orb.agent.MusicalAgentProxyHelper;
import andante.orb.agent.MusicalAgentProxyPOA;

import com.ibm.aglet.AgletProxy;

public class KeyboardProxyImpl extends MusicalAgentProxyPOA {

  MusicalAgent MA = null;
  
  public synchronized void setMusicalAgent(String gid, MusicalAgent ma) {
    MA = ma;
    notify();
  }

  public void run() {    
    try {
      FileInputStream in = new FileInputStream("/dev/midi1");
      int b;
      int data[] = new int[2];
      andante.orb.Message m = new andante.orb.Message();

      synchronized (this) {
        while (MA == null) {
          try {
            wait();
          } catch (InterruptedException ie) {}
        }
      }
      while (true) {
        b = in.read();

        if ((b & 0xf0) == 0x90) {
          //data[0] = (short)(b & 0xf);
          data[0] = in.read();
          data[1] = in.read();
          m.type = MessageType.NOTE_ON;
          m.data = data;
          synchronized (this) {
            MA.processMessage(m);
          }
        }
        else if ((b & 0xf0) == 0x80) {
          //data[0] = (short)(b & 0xf);
          data[0] = (short)in.read();
          data[1] = (short)in.read();
          m.type = MessageType.NOTE_OFF;
          m.data = data;
          synchronized (this) {
            MA.processMessage(m);
          }
        }
        else {
          
        }
      }

    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public static void main (String args[]) {
    try {
      AgletsServer.main(args);

      ORB Orb = ORB.init(args, null);
      
      POA Poa = org.omg.PortableServer.POAHelper.narrow
        ( Orb.resolve_initial_references("RootPOA"));
      Poa.the_POAManager().activate();
      KeyboardProxyImpl kpi = new KeyboardProxyImpl();
      org.omg.CORBA.Object obj = Poa.servant_to_reference(kpi);
      MusicalAgentProxy kp = MusicalAgentProxyHelper.narrow(obj);

      System.out.println(kp);

      AgletProxy proxy = AgletsServer.getContext().createAglet
//	(null, "andante.MAKeyboardProxyChord", kp);
	(null, "andante.MAKeyboardProxyArp", kp);
//      (null, "andante.MAKeyboardProxy", kp);

      proxy.dispatch(new URL(args[0]));

      kpi.run();
      
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

}
