package andante.apps.keyboardproxy;

import andante.apps.noiseweaver.Scales;
import andante.orb.MessageType;
import andante.orb.stage.Stage;

public class MAKeyboardProxyChord extends MAKeyboardProxy {

  private int [] I = new int[128];
  private int [] Deg = new int[128];
  private int [] ScaleSeed;
  private int [] ChordShape = {2,2,3,2,2,2,1};//,3,1,1,2};
  private int ScaleStart;
  

  public void init(Stage stage) {
    super.init(stage);
    for (int i = I.length - 1; i >= 0; i--) {
      I[i] = 0;
    }
    for (int i = Deg.length - 1; i >= 0; i--) {
      Deg[i] = -1;
    }
    ScaleStart = 60;
    ScaleSeed = Scales.getScaleSeed("Diatonic");

    int note = (ScaleStart % 12) - 12;
    int j = 0;
    while (note + ScaleSeed[j] < 0) {
      if (j == ScaleSeed.length - 1) {
        note += 12;
        j = 0;
      }
      else j++;
    } 
    while (note + ScaleSeed[j] < 128) {
      Deg[note + ScaleSeed[j]] = j;
      if (j == ScaleSeed.length - 1) {
        note += 12;
        j = 0;
      }
      else j++;
    }
  }

  public void processMessage (andante.orb.Message m) {
    if (m.type == MessageType.NOTE_ON) {
      if (Deg[m.data[0]] > -1) {
        if (m.data[1] != 0) {
          int j = m.data[0];
          I[j] += 100;
          C.noteOn((short)j, (short)100);
          for (int i = 0; i < ChordShape.length; i++) {
            int step = 0;
            while (j < 128) {
              if (Deg[j] != -1) {
                if (step == ChordShape[i]) break;
                step++;
              }
              j++;
            }
            I[j] += 100;
            System.out.println("on " + j);
            C.noteOn((short)j, (short)100);
          }
        }
        else {
          int j = m.data[0];
          //I[j] -= 100;
          //C.noteOn((short)j,
          //         (short)((127 < I[j])? 127 : I[j]));
          I[j] = 0;
          C.noteOn((short)j,(short)0);
          for (int i = 0; i < ChordShape.length; i++) {
            int step = 0;
            while (j < 128) {
              if (Deg[j] != -1) {
                if (step == ChordShape[i]) break;
                step++;
              }
              j++;
            }
            //I[j] -= 100;
            //C.noteOn((short)j,
            //       (short)((127 < I[j])? 127 : I[j]));
            I[j] = 0;
            C.noteOn((short)j,(short)0);
          }
        }
      }
    }
  }
}
