package andante.device;

import andante.orb.device.*;
import andante.orb.stage.*;
import andante.orb.*;

public class ChannelImpl extends ChannelPOA {

  private AudioDevice DA;
  private int Num;

  Metronome M; 

  public ChannelImpl(AudioDevice d, int channel, Metronome m) {
    DA = d;
    Num = channel;
    M = m;
  }

  public void sendMessage (andante.orb.Message m) {
    DA.sendMessage(Num, m);
  }

  public void playNote(andante.orb.Note n) {
    int [] data = new int[3];
    data[0] = n.pitch;
    data[1] = n.intensity;
//    data[2] = (short)(n.duration * M.getPulseMillis());
    data[2] = n.duration;
//    System.out.println(data[0] + " " + data[1] + " " + data[2]);
    Message m = new Message(MessageType.NOTE_PLAY, data);
    DA.sendMessage(Num, m);
  }

  public void noteOn (short pitch, short intensity) {
    int [] data = new int[2];
    data[0] = pitch;
    data[1] = intensity;
    Message m = new Message(MessageType.NOTE_ON, data);
    DA.sendMessage(Num, m);
  }

  public void noteOff (short pitch, short intensity) {
    int [] data = new int[2];
    data[0] = pitch;
    data[1] = intensity;
    Message m = new Message(MessageType.NOTE_OFF, data);
    DA.sendMessage(Num, m);
  }

  public void changeInstrument(short inst) {
    DA.changeInstrument(Num, inst);
  }

}
