package andante.device;

import org.omg.PortableServer.*;
import andante.orb.device.*;
import andante.orb.*;

import javax.sound.midi.*;
import java.util.*;
import java.io.*;

import java.net.*;

public class OscDevice extends AudioDevicePOA {

  private String Id;
  private DatagramSocket DSocket;
  private Timer T;
  private byte[] Data;
  private DatagramPacket Packet;
  private InetAddress IAddress;
  private int Port;

  public OscDevice(InetAddress address, int port) {

    Id = "OpenSound UDP Device";

    T = new Timer();

    Data = new byte[100];
    try {
      DSocket = new DatagramSocket();
      Packet = new DatagramPacket(Data,Data.length,
                                                 address, port);
      IAddress = address;
      Port = port;
    } catch (Exception e) {
      e.printStackTrace();
    }

    System.out.println("OscDev ok");
  }

  public String id () { return Id; }

  public void sendMessage (int channel, andante.orb.Message m) {
    System.out.println("sendMessage: " + channel);
    Data[0] = (byte) '/';
    Data[1] = (byte) 'p';
    Data[2] = (byte) 'r';
    Data[3] = (byte) 'i';
    Data[4] = (byte) 'n';
    Data[5] = (byte) 't';
    Data[6] = (byte) '\0';
    Data[7] = (byte) '\0';
    Data[8] = (byte) ',';
    Data[9] = (byte) 'i';
    Data[10] = (byte) '\0';
    Data[11] = (byte) '\0';
    Data[12] = (byte) (m.data[0] >> 24);
    Data[13] = (byte) ((m.data[0] >> 16) & 0xff);
    Data[14] = (byte) ((m.data[0] >> 8) & 0xff);
    Data[15] = (byte) (m.data[0] & 0xff);
    System.out.print("Send: ");
    for (int i = 0 ; i < 12; i++) {
      System.out.print(Data[i] + " ");
    }
    System.out.println();

    Packet.setData(Data, 0, 15);
    Packet.setLength(16);
    try {
      DSocket.send(Packet);
    } catch (Exception e) {
      e.printStackTrace();
    }
    System.out.println("Sent.");
  }

  public void playMidiFile (byte[] arq) {}

  public void processSequence (andante.orb.Event[] seq) {}

  public void changeInstrument(int channel, short instr) {}

}
