package andante.stage;

import java.io.*;
import java.util.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;

import andante.device.*;

import andante.orb.agent.*;
import andante.orb.stage.*;
import andante.orb.device.*;
import andante.orb.*;

public class StageImpl extends StagePOA {

  String Id;
  String Name;
  int Tempo;
  AudioDevice D;
  POA Poa;
  andante.orb.stage.Metronome M;

  public StageImpl(String name, AudioDevice da, POA poa) {
    Name = name;
    Tempo = 0;
    Poa = poa;
    D = da;
    M = createMetronome(4, 4, 150);
  }

  /***************************************************************************/

  private andante.orb.stage.Metronome createMetronome(
    int timeAmount, int timeType, int tempo)
  {
    org.omg.CORBA.Object obj = null;
    try {
      obj = Poa.servant_to_reference(this);
      Stage s = StageHelper.narrow(obj);
      MetronomeImpl mi = new MetronomeImpl(s, timeAmount, timeType, tempo);
      obj = Poa.servant_to_reference(mi);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return MetronomeHelper.narrow(obj);
  }

  /***************************************************************************/

  public String id() {
    return Id;
  }

  public andante.orb.stage.Channel channel (int c) {
    org.omg.CORBA.Object obj = null;
    ChannelImpl cmi = new ChannelImpl(D, c, M);
    try {
      obj = Poa.servant_to_reference(cmi);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return ChannelHelper.narrow(obj);
  }

  public void processSequence (andante.orb.Event[] seq) {
    System.out.println("Stage: processSequence " + seq.length);
    D.processSequence(seq);
  }

  public void playMidiFile (byte[] arq) {
    System.out.println("Stage: tocaArquivo");
    D.playMidiFile(arq);
  }


  public andante.orb.stage.Metronome getMetronome() {
    return M;
  }

  /***************************************************************************/

  public static void main(String args[]) {

  }

}
